summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorJim Meyering <meyering@fb.com>2014-05-10 12:36:16 -0700
committerJim Meyering <meyering@fb.com>2014-05-10 12:36:16 -0700
commitd7cfcbef7eb2cd12ac83e5c1c123de2015adbef9 (patch)
treeb3c6bf4e193a230a32986e973caf56116e516c95
parenta7603fa6527cf53a22d5072acb454f65303a3874 (diff)
downloadcoreutils-d7cfcbef7eb2cd12ac83e5c1c123de2015adbef9.tar.xz
shred: don't infloop upon negative size
* src/shred.c (main): With the preceding change, shred -s-2 FILE would write 64KB blocks forever -- or until disk full. This change makes shred reject a negative size. * tests/misc/shred-negative.sh: New file. * tests/local.mk (all_tests): Add it.
-rw-r--r--src/shred.c4
-rw-r--r--tests/local.mk1
-rwxr-xr-xtests/misc/shred-negative.sh28
3 files changed, 31 insertions, 2 deletions
diff --git a/src/shred.c b/src/shred.c
index f4347e002..bd88e3831 100644
--- a/src/shred.c
+++ b/src/shred.c
@@ -1256,8 +1256,8 @@ main (int argc, char **argv)
case 's':
{
- intmax_t tmp;
- if ((xstrtoimax (optarg, NULL, 0, &tmp, "cbBkKMGTPEZY0")
+ uintmax_t tmp;
+ if ((xstrtoumax (optarg, NULL, 0, &tmp, "cbBkKMGTPEZY0")
!= LONGINT_OK)
|| OFF_T_MAX < tmp)
{
diff --git a/tests/local.mk b/tests/local.mk
index 5286bfb34..cd7da5b2f 100644
--- a/tests/local.mk
+++ b/tests/local.mk
@@ -313,6 +313,7 @@ all_tests = \
tests/misc/sha384sum.pl \
tests/misc/sha512sum.pl \
tests/misc/shred-exact.sh \
+ tests/misc/shred-negative.sh \
tests/misc/shred-passes.sh \
tests/misc/shred-remove.sh \
tests/misc/shuf.sh \
diff --git a/tests/misc/shred-negative.sh b/tests/misc/shred-negative.sh
new file mode 100755
index 000000000..86cbf3e02
--- /dev/null
+++ b/tests/misc/shred-negative.sh
@@ -0,0 +1,28 @@
+#!/bin/sh
+# Exercise shred -s-3 FILE
+
+# Copyright (C) 2014 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
+print_ver_ shred
+
+echo 'shred: -2: invalid file size' > exp || framework_failure_
+echo 1234 > f || framework_failure_
+
+shred -s-2 f 2>err && fail=1
+compare exp err || fail=1
+
+Exit $fail